﻿using DbContextLib;
using Model.DTO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Model.Mappers;
using Model.Business;
using Microsoft.EntityFrameworkCore;
using Entities.SQLudeoDB;
using ModelToEntity;

namespace Services
{
    public class UserDataService : IDataService
    {
        private UserDbContext DbContext { get; set; }
        private readonly IDataServiceEF dataServiceEF;
        public UserDataService(IDataServiceEF dataServiceEF) 
        {
            this.dataServiceEF = dataServiceEF;
        }

        public async Task<UserDTO> GetUserById(int id)
        {
            var user = await dataServiceEF.GetUserById(id);
            return user.FromModelToDTO();
        }

        public async Task<UserDTO> GetUserByUsername(string username)
        {
            var user = await dataServiceEF.GetUserByUsername(username);
            return user.FromModelToDTO();
        }

        public async Task<IEnumerable<UserDTO>> GetUsers(int page, int number)
        {
            var users =  await dataServiceEF.GetUsers(page, number);
            return users.Select(u => u.FromModelToDTO());
        }

        public async Task<bool> DeleteUser(int id)
        {
            var respons = await dataServiceEF.DeleteUser(id);
            return respons;
        }

        public async Task<UserDTO> UpdateUser(int id, UserDTO user)
        {
            var updatingUser = await dataServiceEF.UpdateUser(id, user);
            return updatingUser.FromModelToDTO();
        }
        public async Task<UserDTO> CreateUser(string username, string password, string email, bool isAdmin)
        {
            var newUserEntity =  await dataServiceEF.CreateUser(username, password, email, isAdmin);
            return newUserEntity.FromModelToDTO();
        }

        public IEnumerable<InquiryDTO> GetInquiries(int page, int number)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO GetInquiryById(int id)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO GetInquiryByTitle(string title)
        {
            throw new NotImplementedException();
        }
        public UserDTO CreateInquiry(string title, string description, bool isUser, InquiryTableEntity database, SolutionEntity inquiryTable)
        {
            throw new NotImplementedException();
        }

        public bool DeleteInquiry(int id)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO UpdateInquiry(int id, InquiryDTO inquiry)
        {
            throw new NotImplementedException();
        }

        public IEnumerable<InquiryDTO> GetLessons(int page, int number)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO GetLessonById(int id)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO GetLessonByTitle(string title)
        {
            throw new NotImplementedException();
        }

        public bool DeleteLesson(int id)
        {
            throw new NotImplementedException();
        }

        public InquiryDTO UpdateLesson(int id, LessonDTO lesson)
        {
            throw new NotImplementedException();
        }

        public UserDTO CreateLesson(string title, string lastPublisher, DateOnly lastEdit)
        {
            throw new NotImplementedException();
        }
    }
}
